# Generated by Django 4.2.2 on 2023-06-24 18:55

import django.db.models.deletion
import django.utils.timezone
from django.db import migrations, models

import simpleidentity.models


class Migration(migrations.Migration):
    initial = True

    dependencies: list[str] = []

    operations = [
        migrations.CreateModel(
            name="Entity",
            fields=[
                (
                    "id",
                    models.UUIDField(
                        default=simpleidentity.models._make_uuid4,
                        editable=False,
                        primary_key=True,
                        serialize=False,
                        unique=True,
                    ),
                ),
                (
                    "created_at",
                    models.DateTimeField(
                        auto_now_add=True,
                        help_text="Date and time at which this resource record was first created",
                    ),
                ),
                (
                    "updated_at",
                    models.DateTimeField(
                        auto_now=True,
                        help_text="Date and time at which this resource record was last changed",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="Group",
            fields=[
                (
                    "created_at",
                    models.DateTimeField(
                        auto_now_add=True,
                        help_text="Date and time at which this resource record was first created",
                    ),
                ),
                (
                    "updated_at",
                    models.DateTimeField(
                        auto_now=True,
                        help_text="Date and time at which this resource record was last changed",
                    ),
                ),
                (
                    "entity",
                    models.OneToOneField(
                        editable=False,
                        on_delete=django.db.models.deletion.CASCADE,
                        primary_key=True,
                        serialize=False,
                        to="simpleidentity.entity",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="Institution",
            fields=[
                (
                    "created_at",
                    models.DateTimeField(
                        auto_now_add=True,
                        help_text="Date and time at which this resource record was first created",
                    ),
                ),
                (
                    "updated_at",
                    models.DateTimeField(
                        auto_now=True,
                        help_text="Date and time at which this resource record was last changed",
                    ),
                ),
                (
                    "entity",
                    models.OneToOneField(
                        editable=False,
                        on_delete=django.db.models.deletion.CASCADE,
                        primary_key=True,
                        serialize=False,
                        to="simpleidentity.entity",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="Person",
            fields=[
                (
                    "created_at",
                    models.DateTimeField(
                        auto_now_add=True,
                        help_text="Date and time at which this resource record was first created",
                    ),
                ),
                (
                    "updated_at",
                    models.DateTimeField(
                        auto_now=True,
                        help_text="Date and time at which this resource record was last changed",
                    ),
                ),
                (
                    "entity",
                    models.OneToOneField(
                        editable=False,
                        on_delete=django.db.models.deletion.CASCADE,
                        primary_key=True,
                        serialize=False,
                        to="simpleidentity.entity",
                    ),
                ),
            ],
            options={
                "verbose_name_plural": "people",
            },
        ),
        migrations.CreateModel(
            name="NaturalIdentity",
            fields=[
                (
                    "id",
                    models.UUIDField(
                        default=simpleidentity.models._make_uuid4,
                        editable=False,
                        primary_key=True,
                        serialize=False,
                        unique=True,
                    ),
                ),
                (
                    "created_at",
                    models.DateTimeField(
                        auto_now_add=True,
                        help_text="Date and time at which this resource record was first created",
                    ),
                ),
                (
                    "updated_at",
                    models.DateTimeField(
                        auto_now=True,
                        help_text="Date and time at which this resource record was last changed",
                    ),
                ),
                (
                    "became_effective_at",
                    models.DateTimeField(default=django.utils.timezone.now, editable=False),
                ),
                ("first_name", models.CharField(blank=True, default="")),
                ("middle_name", models.CharField(blank=True, default="")),
                ("last_name", models.CharField()),
                ("name_suffix", models.CharField(blank=True, default="")),
                (
                    "person",
                    models.ForeignKey(
                        editable=False,
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="natural_identities",
                        to="simpleidentity.person",
                    ),
                ),
            ],
            options={
                "verbose_name_plural": "natural identities",
                "indexes": [
                    models.Index(
                        fields=["person_id", "became_effective_at"],
                        name="person_became_effective_at",
                    )
                ],
            },
        ),
        migrations.AddConstraint(
            model_name="naturalidentity",
            constraint=models.UniqueConstraint(
                fields=("person_id", "became_effective_at"),
                name="natural_identity_composite_pk_constaint",
            ),
        ),
    ]
